
/*  @(#)graphics.h 1.3 02/02/15
 *
 *  External variable definitions used by the popi program
 *  optional graphics module.
 *
 *  Popi was originally written by Gerard J. Holzmann - AT&T Bell Labs.
 *  This version is based on the code in his Prentice Hall book,
 *  "Beyond Photography - the digital darkroom," ISBN 0-13-074410-7,
 *  which is copyright (c) 1988 by Bell Telephone Laboratories, Inc. 
 *
 *  Copyright (c) 1989-2002 - Rich Burridge, Sun Microsystems Inc.
 *  All rights reserved.
 *
 *  Permission is given to distribute these sources, as long as the
 *  copyright messages are not removed, and no monies are exchanged.
 *
 *  No responsibility is taken for any errors or inaccuracies inherent
 *  either to the comments or the code of this program, but if
 *  reported to me, then an attempt will be made to fix them.
 */

#define WRITE  (void) write
#define IOCTL  (void) ioctl

/* External declarations for the variables declared in graphics.c. */

extern char geometry[];       /* X11 geometry information. */
extern char x11_display[];    /* X11 display information. */
 
extern unsigned char *mptr;   /* Pointer to scanline data. */
 
extern int iconic;            /* Set if the window is in an iconic state. */
